// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package cloud9

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// Cloud9 provides the API operation methods for making requests to
// AWS Cloud9. See this package's package overview docs
// for details on the service.
//
// Cloud9 methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type Cloud9 struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*Cloud9)

// Used for custom request initialization logic
var initRequest func(*Cloud9, *aws.Request)

// Service information constants
const (
	ServiceName = "cloud9"    // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the Cloud9 client with a config.
//
// Example:
//     // Create a Cloud9 client from just a config.
//     svc := cloud9.New(myConfig)
func New(config aws.Config) *Cloud9 {
	var signingName string
	signingRegion := config.Region

	svc := &Cloud9{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2017-09-23",
				JSONVersion:   "1.1",
				TargetPrefix:  "AWSCloud9WorkspaceManagementService",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a Cloud9 operation and runs any
// custom request initialization.
func (c *Cloud9) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
