// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package datapipeline

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// DataPipeline provides the API operation methods for making requests to
// AWS Data Pipeline. See this package's package overview docs
// for details on the service.
//
// DataPipeline methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type DataPipeline struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*DataPipeline)

// Used for custom request initialization logic
var initRequest func(*DataPipeline, *aws.Request)

// Service information constants
const (
	ServiceName = "datapipeline" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName    // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the DataPipeline client with a config.
//
// Example:
//     // Create a DataPipeline client from just a config.
//     svc := datapipeline.New(myConfig)
func New(config aws.Config) *DataPipeline {
	var signingName string
	signingRegion := config.Region

	svc := &DataPipeline{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2012-10-29",
				JSONVersion:   "1.1",
				TargetPrefix:  "DataPipeline",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a DataPipeline operation and runs any
// custom request initialization.
func (c *DataPipeline) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
