// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package dynamodbstreams

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// DynamoDBStreams provides the API operation methods for making requests to
// Amazon DynamoDB Streams. See this package's package overview docs
// for details on the service.
//
// DynamoDBStreams methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type DynamoDBStreams struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*DynamoDBStreams)

// Used for custom request initialization logic
var initRequest func(*DynamoDBStreams, *aws.Request)

// Service information constants
const (
	ServiceName = "streams.dynamodb" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName        // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the DynamoDBStreams client with a config.
//
// Example:
//     // Create a DynamoDBStreams client from just a config.
//     svc := dynamodbstreams.New(myConfig)
func New(config aws.Config) *DynamoDBStreams {
	var signingName string
	signingName = "dynamodb"
	signingRegion := config.Region

	svc := &DynamoDBStreams{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2012-08-10",
				JSONVersion:   "1.0",
				TargetPrefix:  "DynamoDBStreams_20120810",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a DynamoDBStreams operation and runs any
// custom request initialization.
func (c *DynamoDBStreams) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
