// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package elasticsearchservice

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// ElasticsearchService provides the API operation methods for making requests to
// Amazon Elasticsearch Service. See this package's package overview docs
// for details on the service.
//
// ElasticsearchService methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type ElasticsearchService struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*ElasticsearchService)

// Used for custom request initialization logic
var initRequest func(*ElasticsearchService, *aws.Request)

// Service information constants
const (
	ServiceName = "es"        // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the ElasticsearchService client with a config.
//
// Example:
//     // Create a ElasticsearchService client from just a config.
//     svc := elasticsearchservice.New(myConfig)
func New(config aws.Config) *ElasticsearchService {
	var signingName string
	signingRegion := config.Region

	svc := &ElasticsearchService{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2015-01-01",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a ElasticsearchService operation and runs any
// custom request initialization.
func (c *ElasticsearchService) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
