// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package iot

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// IoT provides the API operation methods for making requests to
// AWS IoT. See this package's package overview docs
// for details on the service.
//
// IoT methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type IoT struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*IoT)

// Used for custom request initialization logic
var initRequest func(*IoT, *aws.Request)

// Service information constants
const (
	ServiceName = "iot"       // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the IoT client with a config.
//
// Example:
//     // Create a IoT client from just a config.
//     svc := iot.New(myConfig)
func New(config aws.Config) *IoT {
	var signingName string
	signingName = "execute-api"
	signingRegion := config.Region

	svc := &IoT{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2015-05-28",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a IoT operation and runs any
// custom request initialization.
func (c *IoT) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
