// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package iot1clickdevicesservice

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// IoT1ClickDevicesService provides the API operation methods for making requests to
// AWS IoT 1-Click Devices Service. See this package's package overview docs
// for details on the service.
//
// IoT1ClickDevicesService methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type IoT1ClickDevicesService struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*IoT1ClickDevicesService)

// Used for custom request initialization logic
var initRequest func(*IoT1ClickDevicesService, *aws.Request)

// Service information constants
const (
	ServiceName = "devices.iot1click" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName         // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the IoT1ClickDevicesService client with a config.
//
// Example:
//     // Create a IoT1ClickDevicesService client from just a config.
//     svc := iot1clickdevicesservice.New(myConfig)
func New(config aws.Config) *IoT1ClickDevicesService {
	var signingName string
	signingName = "iot1click"
	signingRegion := config.Region

	svc := &IoT1ClickDevicesService{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-05-14",
				JSONVersion:   "1.1",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a IoT1ClickDevicesService operation and runs any
// custom request initialization.
func (c *IoT1ClickDevicesService) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
