// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package opsworkscm

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// OpsWorksCM provides the API operation methods for making requests to
// AWS OpsWorks for Chef Automate. See this package's package overview docs
// for details on the service.
//
// OpsWorksCM methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type OpsWorksCM struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*OpsWorksCM)

// Used for custom request initialization logic
var initRequest func(*OpsWorksCM, *aws.Request)

// Service information constants
const (
	ServiceName = "opsworks-cm" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName   // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the OpsWorksCM client with a config.
//
// Example:
//     // Create a OpsWorksCM client from just a config.
//     svc := opsworkscm.New(myConfig)
func New(config aws.Config) *OpsWorksCM {
	var signingName string
	signingName = "opsworks-cm"
	signingRegion := config.Region

	svc := &OpsWorksCM{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2016-11-01",
				JSONVersion:   "1.1",
				TargetPrefix:  "OpsWorksCM_V2016_11_01",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a OpsWorksCM operation and runs any
// custom request initialization.
func (c *OpsWorksCM) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
