// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package pricing

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// Pricing provides the API operation methods for making requests to
// AWS Price List Service. See this package's package overview docs
// for details on the service.
//
// Pricing methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type Pricing struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*Pricing)

// Used for custom request initialization logic
var initRequest func(*Pricing, *aws.Request)

// Service information constants
const (
	ServiceName = "api.pricing" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName   // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the Pricing client with a config.
//
// Example:
//     // Create a Pricing client from just a config.
//     svc := pricing.New(myConfig)
func New(config aws.Config) *Pricing {
	var signingName string
	signingName = "pricing"
	signingRegion := config.Region

	svc := &Pricing{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2017-10-15",
				JSONVersion:   "1.1",
				TargetPrefix:  "AWSPriceListService",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a Pricing operation and runs any
// custom request initialization.
func (c *Pricing) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
