// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package robomaker

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// RoboMaker provides the API operation methods for making requests to
// AWS RoboMaker. See this package's package overview docs
// for details on the service.
//
// RoboMaker methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type RoboMaker struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*RoboMaker)

// Used for custom request initialization logic
var initRequest func(*RoboMaker, *aws.Request)

// Service information constants
const (
	ServiceName = "robomaker" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the RoboMaker client with a config.
//
// Example:
//     // Create a RoboMaker client from just a config.
//     svc := robomaker.New(myConfig)
func New(config aws.Config) *RoboMaker {
	var signingName string
	signingName = "robomaker"
	signingRegion := config.Region

	svc := &RoboMaker{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-06-29",
				JSONVersion:   "1.1",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a RoboMaker operation and runs any
// custom request initialization.
func (c *RoboMaker) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
