// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package route53domains

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// Route53Domains provides the API operation methods for making requests to
// Amazon Route 53 Domains. See this package's package overview docs
// for details on the service.
//
// Route53Domains methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type Route53Domains struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*Route53Domains)

// Used for custom request initialization logic
var initRequest func(*Route53Domains, *aws.Request)

// Service information constants
const (
	ServiceName = "route53domains" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName      // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the Route53Domains client with a config.
//
// Example:
//     // Create a Route53Domains client from just a config.
//     svc := route53domains.New(myConfig)
func New(config aws.Config) *Route53Domains {
	var signingName string
	signingRegion := config.Region

	svc := &Route53Domains{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2014-05-15",
				JSONVersion:   "1.1",
				TargetPrefix:  "Route53Domains_v20140515",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a Route53Domains operation and runs any
// custom request initialization.
func (c *Route53Domains) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
