// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package route53resolver

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/jsonrpc"
)

// Route53Resolver provides the API operation methods for making requests to
// Amazon Route 53 Resolver. See this package's package overview docs
// for details on the service.
//
// Route53Resolver methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type Route53Resolver struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*Route53Resolver)

// Used for custom request initialization logic
var initRequest func(*Route53Resolver, *aws.Request)

// Service information constants
const (
	ServiceName = "route53resolver" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName       // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the Route53Resolver client with a config.
//
// Example:
//     // Create a Route53Resolver client from just a config.
//     svc := route53resolver.New(myConfig)
func New(config aws.Config) *Route53Resolver {
	var signingName string
	signingRegion := config.Region

	svc := &Route53Resolver{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-04-01",
				JSONVersion:   "1.1",
				TargetPrefix:  "Route53Resolver",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(jsonrpc.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(jsonrpc.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(jsonrpc.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(jsonrpc.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a Route53Resolver operation and runs any
// custom request initialization.
func (c *Route53Resolver) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
