// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package s3control

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restxml"
)

// S3Control provides the API operation methods for making requests to
// AWS S3 Control. See this package's package overview docs
// for details on the service.
//
// S3Control methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type S3Control struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*S3Control)

// Used for custom request initialization logic
var initRequest func(*S3Control, *aws.Request)

// Service information constants
const (
	ServiceName = "s3-control" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName  // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the S3Control client with a config.
//
// Example:
//     // Create a S3Control client from just a config.
//     svc := s3control.New(myConfig)
func New(config aws.Config) *S3Control {
	var signingName string
	signingName = "s3"
	signingRegion := config.Region

	svc := &S3Control{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2018-08-20",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restxml.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restxml.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restxml.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restxml.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a S3Control operation and runs any
// custom request initialization.
func (c *S3Control) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
