// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package transcribeserviceiface provides an interface to enable mocking the Amazon Transcribe Service service client
// for testing your code.
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters.
package transcribeserviceiface

import (
	"github.com/aws/aws-sdk-go-v2/service/transcribeservice"
)

// TranscribeServiceAPI provides an interface to enable mocking the
// transcribeservice.TranscribeService service client's API operation,
// paginators, and waiters. This make unit testing your code that calls out
// to the SDK's service client's calls easier.
//
// The best way to use this interface is so the SDK's service client's calls
// can be stubbed out for unit testing your code with the SDK without needing
// to inject custom request handlers into the SDK's request pipeline.
//
//    // myFunc uses an SDK service client to make a request to
//    // Amazon Transcribe Service.
//    func myFunc(svc transcribeserviceiface.TranscribeServiceAPI) bool {
//        // Make svc.CreateVocabulary request
//    }
//
//    func main() {
//        cfg, err := external.LoadDefaultAWSConfig()
//        if err != nil {
//            panic("failed to load config, " + err.Error())
//        }
//
//        svc := transcribeservice.New(cfg)
//
//        myFunc(svc)
//    }
//
// In your _test.go file:
//
//    // Define a mock struct to be used in your unit tests of myFunc.
//    type mockTranscribeServiceClient struct {
//        transcribeserviceiface.TranscribeServiceAPI
//    }
//    func (m *mockTranscribeServiceClient) CreateVocabulary(input *transcribeservice.CreateVocabularyInput) (*transcribeservice.CreateVocabularyOutput, error) {
//        // mock response/functionality
//    }
//
//    func TestMyFunc(t *testing.T) {
//        // Setup Test
//        mockSvc := &mockTranscribeServiceClient{}
//
//        myfunc(mockSvc)
//
//        // Verify myFunc's functionality
//    }
//
// It is important to note that this interface will have breaking changes
// when the service model is updated and adds new API operations, paginators,
// and waiters. Its suggested to use the pattern above for testing, or using
// tooling to generate mocks to satisfy the interfaces.
type TranscribeServiceAPI interface {
	CreateVocabularyRequest(*transcribeservice.CreateVocabularyInput) transcribeservice.CreateVocabularyRequest

	DeleteTranscriptionJobRequest(*transcribeservice.DeleteTranscriptionJobInput) transcribeservice.DeleteTranscriptionJobRequest

	DeleteVocabularyRequest(*transcribeservice.DeleteVocabularyInput) transcribeservice.DeleteVocabularyRequest

	GetTranscriptionJobRequest(*transcribeservice.GetTranscriptionJobInput) transcribeservice.GetTranscriptionJobRequest

	GetVocabularyRequest(*transcribeservice.GetVocabularyInput) transcribeservice.GetVocabularyRequest

	ListTranscriptionJobsRequest(*transcribeservice.ListTranscriptionJobsInput) transcribeservice.ListTranscriptionJobsRequest

	ListVocabulariesRequest(*transcribeservice.ListVocabulariesInput) transcribeservice.ListVocabulariesRequest

	StartTranscriptionJobRequest(*transcribeservice.StartTranscriptionJobInput) transcribeservice.StartTranscriptionJobRequest

	UpdateVocabularyRequest(*transcribeservice.UpdateVocabularyInput) transcribeservice.UpdateVocabularyRequest
}

var _ TranscribeServiceAPI = (*transcribeservice.TranscribeService)(nil)
